"use strict";
var React = require("react");
var react_dom_1 = require("react-dom");
var mobx_react_1 = require("mobx-react");
var Cans = (function () {
    function Cans() {
        this.__routerComponent = React.createElement('div', null, 'cans');
        this.stores = [];
    }
    Cans.prototype.__getInjectList = function () {
        return this.stores.map(function (store) { return store.namespace; }).filter(function (_) { return _; });
    };
    Cans.prototype.route = function (routeFunc) {
        // wrap provider
        var providerProps = {};
        this.stores.forEach(function (store) {
            providerProps[store.namespace] = store;
        });
        this.__routerComponent = React.createElement(mobx_react_1.Provider, providerProps, routeFunc());
    };
    Cans.prototype.store = function (store) {
        this.stores.push(store);
    };
    Cans.prototype.start = function (el) {
        react_dom_1.render(this.__routerComponent, el);
        this.__mountedRoot = el;
    };
    Cans.prototype.observer = function (view) {
        var injection = mobx_react_1.inject(function (stores) { return ({ stores: stores }); });
        return injection(mobx_react_1.observer(view));
    };
    return Cans;
}());
exports.Cans = Cans;
var createCansApp = function () {
    return new Cans();
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = createCansApp;
module.exports = createCansApp;
